<template>
  <v-row class="mx-0">
    <v-col cols="8">
      <v-card class="pt-4">
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-smartphone' : 'dialog-content-scrollerd'">
          <v-form ref="form" @submit.prevent="validarFormulario">
            <v-row align="center">
              <v-col :cols="12">
                <v-btn
                  :block="$vuetify.breakpoint.smAndDown"
                  color="accent"
                  @click="dialogListaCliente=true"
                >
                  Seleccionar cliente
                </v-btn>
                <v-btn
                  v-if="!cliente"
                  :block="$vuetify.breakpoint.smAndDown"
                  color="secondary"
                  :class="$vuetify.breakpoint.smAndDown ? 'mt-2' : 'ma-2'"
                  @click="dialogCliente = true"
                >
                  Agregar nuevo
                  <v-icon
                    right
                    dark
                  >
                    fas fa-user-plus
                  </v-icon>
                </v-btn>
              </v-col>
              <v-col :cols="$vuetify.breakpoint.smAndDown ? 12 : 6">
                <v-alert
                  v-if="cliente"
                  text
                  dense
                  color="accent"
                  border="left"
                >
                  <v-row align="center">
                    <v-col class="grow">
                      <tr>Nombre: {{ clienteActual.nombre }}</tr>
                      <tr>DNI: {{ clienteActual.dni }}</tr>
                    </v-col>
                    <v-col class="shrink">
                      <v-btn @click="dialogDetalleCliente=true">
                        Detalle
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-alert>
              </v-col>
            </v-row>
            <v-btn :block="$vuetify.breakpoint.smAndDown" color="accent" @click="dialogProductos=true">
              Agregar producto
            </v-btn>
            <v-data-table
              :items-per-page="10"
              :headers="headers"
              :items="formVentas.detalle"
              class="elevation-1"
            >
              <template #[`item.cantidad`]="props">
                <v-edit-dialog
                  @close="calcularTotal(formVentas.detalle)"
                >
                  {{ props.item.cantidad }}
                  <template #input>
                    <v-text-field
                      v-model="props.item.cantidad"
                      label="Editar"
                      single-line
                    />
                  </template>
                </v-edit-dialog>
              </template>
              <template #[`item.precio_venta`]="props">
                <v-edit-dialog
                  @close="calcularTotal(formVentas.detalle)"
                >
                  $ {{ props.item.precio_venta }}
                  <template #input>
                    <v-text-field
                      v-model="props.item.precio_venta"
                      label="Editar"
                      single-line
                    />
                  </template>
                </v-edit-dialog>
              </template>
              <template #[`item.subTotal`]="props">
                $ {{ props.item.precio_venta * props.item.cantidad }}
              </template>
              <template #[`item.action`]="{ item }">
                <v-icon
                  small
                  class="fal fa-trash-alt"
                  @click="removeProducto(item)"
                />
              </template>
            </v-data-table>
          </v-form>
        </v-card-text>
        <v-btn block @click="dialogVentas = true">
          Ventas realizadas
        </v-btn>
        <v-dialog v-model="dialogListaCliente" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
          <v-card>
            <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
              <lista-clientes v-if="dialogListaCliente" :seleccionable="true" :cliente-seleccionado="clienteActual" @selectedCliente="actualizarCliente" />
            </v-card-text>
            <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
              <v-btn class="elevation-2 font-weight-light" @click="dialogListaCliente = false">
                Cerrar
              </v-btn>
              <v-spacer />
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogProductos" width="1400" :fullscreen="this.$vuetify.breakpoint.smAndDown">
          <lista-productos v-if="dialogProductos" :seleccionable="true" :total="formVentas.total" @addProduct="agregarProducto" @onClose="cerrarDialogProductos" />
        </v-dialog>
        <v-dialog v-model="dialogDetalleCliente" width="700" :fullscreen="this.$vuetify.breakpoint.smAndDown">
          <detalle-cliente v-if="dialogDetalleCliente" :cliente="clienteActual" @onClose="dialogDetalleCliente = false" />
        </v-dialog>
        <v-dialog v-model="dialogCliente" width="500" :fullscreen="$vuetify.breakpoint.smAndDown">
          <form-clientes v-if="dialogCliente" :form-desde-ventas="true" @onClose="dialogCliente = false" @addedCliente="actualizarCliente" />
        </v-dialog>
        <!--        <v-dialog v-model="dialogPago" width="500">-->
        <!--          &lt;!&ndash;-->
        <!--                <form-pagos v-if="dialogPago" :cliente="cliente" @onClose="cerrarDialogPago" />-->
        <!--          &ndash;&gt;-->
        <!--        </v-dialog>-->
        <v-dialog v-model="dialogVentas" width="1000" :fullscreen="$vuetify.breakpoint.smAndDown">
          <v-card>
            <v-card-title>Ventas realizadas</v-card-title>
            <v-card-text>
              <lista-ventas v-if="dialogVentas" />
            </v-card-text>
            <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
              <v-spacer />
              <v-btn @click="dialogVentas = false">
                Cerrar
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <up-web-view v-if="showDialogPDF" :url="urlPDF" @onClose="showDialogPDF=false" />
      </v-card>
    </v-col>
    <v-col>
      <v-card>
        <v-card-title>
          <v-icon class="mr-2">
            fal fa-shopping-cart
          </v-icon>
          Datos de factura
        </v-card-title>
        <v-card-text>
          <v-text-field
            v-model="numeroFactura"
            label="N° de factura"
            disabled
            type="text"
            required
            color="accent"
          />
          <v-text-field
            v-model="nombreClienteFinal"
            label="Cliente"
            disabled
            type="text"
            required
            color="accent"
          />
          <v-text-field
            v-model="fechaYHora"
            label="Fecha y hora"
            disabled
            type="text"
            required
            color="accent"
          />
          <v-text-field
            v-model="formVentas.subTotal"
            prepend-icon="$"
            label="Subtotal"
            disabled
            type="text"
            required
            color="accent"
          />
          <v-text-field
            v-model="formVentas.IVA"
            append-icon="%"
            label="IVA"
            disabled
            type="text"
            required
            color="accent"
          />
          <v-text-field
            v-model="formVentas.total"
            prepend-icon="$"
            label="TOTAL"
            disabled
            type="text"
            required
            color="accent"
          />
          <v-text-field
            v-model="formVentas.rinde"
            prepend-icon="$"
            label="Rinde"
            type="text"
            required
            :rules="rules.nombre"
            color="accent"
          />

          <v-text-field
            v-model="formVentas.vuelto"
            prepend-icon="$"
            label="Vuelto"
            disabled
            type="text"
            required
            color="accent"
          />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-spacer />
          <v-btn class="elevation-2 font-weight-light accent" @click="validarFormulario">
            Confirmar venta
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import { Component, Ref, Vue, Watch } from 'vue-property-decorator'
import listaClientes from '../clientes/listaClientes.vue'
import { Cliente } from '~/core/models/cliente'; import { ClientesStore } from '~/store/ClientesStore'
import FormClientes from '~/components/clientes/formClientes.vue'
import ListaProductos from '~/components/productos/listaProductos.vue'; import { Venta } from '~/core/models/venta'
import AppToast from '~/core/utils/AppToast'; import { AppStore } from '~/store/AppStore'
import { VentasStore } from '~/store/VentasStore'; import { ProductosStore } from '~/store/ProductosStore'
import DetalleCliente from '~/components/clientes/detalleCliente.vue'
import { DateHelpers } from '~/core/helpers/DateHelpers'
import ListaVentas from '~/components/ventas/listaVentas.vue'
import UpWebView from '~/components/shared/UpWebView.vue'
import { App } from '~/core/App'
    @Component({
      components: { UpWebView, ListaVentas, DetalleCliente, ListaProductos, FormClientes, listaClientes }
    })
export default class formVentas extends Vue {
        @Ref('form') formulario:any;

        dialogListaCliente:boolean =false;
        dialogCliente:boolean = false;
        dialogPago:boolean = false;
        dialogProductos:boolean = false;
        dialogVentas:boolean = false;
        dialogDetalleCliente:boolean = false;
        clienteActual:Cliente = null;
        showDialogPDF:boolean = false;
        urlPDF:string = '';

        formVentas:Venta = {
          clientes_idclientes: null,
          detalle: [],
          total: '0',
          subTotal: 0,
          IVA: 21,
          rinde: '0',
          vuelto: 0
        };

        headers = [
          { text: 'Código', align: 'left', value: 'codigo' },
          { text: 'Producto', align: 'left', value: 'nombre' },
          { text: 'Cantidad', align: 'left', value: 'cantidad' },
          { text: 'Precio de venta', align: 'right', value: 'precio_venta' },
          { text: 'Subtotal', align: 'right', value: 'subTotal' },
          { value: 'action', align: 'right', sortable: false }

        ];

        rules = {
          nombre: [
            v => !!v || 'Campo requerido'
          ],
          dni: [
            v => !!v || 'DNI es requerido',
            v => /^[0-9]*$/.test(v) || 'Solo debe ingresar números',
            v => /^[0-9]{5,15}$/.test(v) || 'El número no alcanza el mínimo de dígitos o supera el máximo de dígitos'
          ]
        };

        get idVentas ():number[] {
          return VentasStore.listaVentas ? VentasStore.listaVentas.map(p => p.idventas) : [0]
        }

        get numeroFactura ():number {
          return Math.max(...this.idVentas) + 1
        }

        get nombreClienteFinal ():string {
          return this.clienteActual ? this.clienteActual.nombre : 'Por favor seleccione un cliente'
        }

        get fechaYHora () {
          return DateHelpers.getFechaHoyHumanFechaFull()
        }

      @Watch('formVentas.rinde')
        calcularVuelto () {
          this.formVentas.vuelto = Number(this.formVentas.rinde) - Number(this.formVentas.total)
        }

      mounted () {
        formVentas.descargardatos()
      }

      private static async descargardatos () {
        AppStore.SHOW_LOADING('Cargando...')

        try {
          await ProductosStore.descargarListaProductos()
          VentasStore.descargarListaVentas()
        } catch (e) {
        }

        AppStore.HIDE_LOADING()
      }

      /*         @Watch("dniCliente")
        DNIchange(val){

            let cliente:Cliente = this.dniCliente &&
                ClientesStore.listaClientes.find(p => p.dni.toString() === this.dniCliente.toString());

            if (cliente){
                this.formVentas.clientes_idclientes = cliente.idclientes
            }else {
                this.formVentas.clientes_idclientes = null;
            }
        }
 */
      get cliente ():Cliente {
        return this.formVentas.clientes_idclientes && ClientesStore.listaClientes.find(p => p.idclientes === this.formVentas.clientes_idclientes)
      }

      agregarProducto (producto) {
        this.formVentas.detalle.push(...producto)
        this.calcularTotal(this.formVentas.detalle)
        this.dialogProductos = false
      }

      removeProducto (posicion) {
        // eliminamos el item de la posicion indicada
        this.formVentas.detalle.splice(posicion, 1)
        this.calcularTotal(this.formVentas.detalle)
      }

      dialogListaClientes () {
      }

      calcularTotal (producto) {
        const valores = producto.map(p => Number(p.precio_venta) * p.cantidad)
        let subTotal = 0
        for (const index in valores) {
          subTotal += valores[index]
        }
        this.formVentas.subTotal = subTotal
        this.formVentas.total = String(subTotal + ((subTotal * this.formVentas.IVA) / 100))
      }

      actualizarCliente (cliente:Cliente) {
        this.dialogListaCliente = false
        if (cliente) {
          this.clienteActual = cliente
          this.formVentas.clientes_idclientes = cliente.idclientes
        } else {
          this.clienteActual = null
          this.formVentas.clientes_idclientes = null
        }
      }

      validarFormulario () {
        if (this.formulario.validate()) {
          if (this.clienteActual) { this.guardar() } else { AppToast.error('Por favor seleccione un cliente') }
        } else {
          AppToast.error('Campos inválidos')
        }
      }

      private async guardar () {
        AppStore.SHOW_LOADING('Guardando venta')
        try {
          await VentasStore.registrarVentas(this.formVentas)
          await this.imprimirRecibo()
          this.vaciarCampos()
          AppToast.success('Venta registrada')
        } catch (e) {
        }
        AppStore.HIDE_LOADING()
      }

      vaciarCampos () {
        this.formVentas.clientes_idclientes = null
        this.formVentas.detalle = []
        this.clienteActual = null
        this.formVentas.total = '0'
        this.formVentas.subTotal = 0
        this.formVentas.rinde = '0'
        this.formVentas.vuelto = 0
      }

      async pagarVenta () {
        const res = await this.$confirm('¿Desea pagar ahora mismo?', { buttonTrueText: 'Si', buttonTrueColor: 'accent' })
        if (res) {
          this.dialogPago = true
        } else {
          this.cerrarDialog()
        }
      }

      cerrarDialog () {
        this.formVentas.clientes_idclientes = null
        this.formVentas.detalle = []
        this.clienteActual = null
        this.$emit('onClose')
      }

      cerrarDialogProductos () {
        this.dialogProductos = false
      }

      cerrarDialogPago () {
        this.dialogPago = false
        this.formVentas.clientes_idclientes = null
        this.formVentas.detalle = []
        this.cerrarDialog()
      }

      imprimirRecibo () {
        const f = {
          idclientes: this.formVentas.clientes_idclientes
        }

        AppStore.SHOW_LOADING('Descargando datos...')

        const url = 'comprobantes/recibo'
        App.$axios.get(url, {
          headers: { Accept: 'application/json' },
          params: f,
          responseType: 'blob'
        }).then((res) => {
          const data: Blob = res.data

          this.urlPDF = window.URL.createObjectURL(data)
          this.showDialogPDF = true
        }).catch(() => {
          AppToast.error('Hubo un error al descargar los datos para imprimir')
        }).finally(() => {
          AppStore.HIDE_LOADING()
        })
      }
}
</script>

<style lang="scss">

</style>
